/***************************************************************************
                          conditional.h  -  description
                             -------------------
    begin                : Fri Nov 23 2001
    copyright            : (C) 2001, 2002 by Thomas Friedrichsmeier
    email                : Thomas.Friedrichsmeier@ruhr-uni-bochum.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CONDITIONAL_H
#define CONDITIONAL_H

#include "tpbase.h"

/**A conditional is basically a list of states and a the required state (on/off) of those states
+ a member function checking whether this list of conditions is met.
  *@author Thomas Friedrichsmeier
  */

class QDomElement;
class State;

class Conditional : public TPBase {
public: 
	Conditional(QDomElement const & description);
	~Conditional();
/** Returns, whether the conditions are met */
	bool fulfilled ();
private:
/** Reads in the configuration for this conditional */
	void read_conditional (QDomElement const & description);
	struct Condition {
	/** State to be checked */
		State *state;
	/** Condition to be checked against */
		bool required;	
	} * conditions;
/** Number of conditions to be checked */
	unsigned int num_conditions;
};

#endif
